{													}
{	PAP.p											}
{	Pascal Interface to PAP.WrkStation.o			}
{													}
{	Copyright Apple Computer, Inc. 1992-1995		}
{	All rights reserved								}
{													}

UNIT PAP;

INTERFACE

	USES
		Types, AppleTalk;

	CONST
		PAPMaxDataSize	= 512;		{ Maximum data size per flow quantum }

		PAPNoCCBs		= -4096;	{ No free CCBs available }
		PAPNoPrinter	= -4101;	{ Printer or print server not found }
		PAPConnClosed	= -4100;	{ Connection just closed }
		PAPBadRefnum	= -4097;	{ Bad connection refnum }
		PAPActive		= -4098;	{ Request already active }
		PAPTooBig		= -4099;	{ Write request too big }

	TYPE
		PAPStatusRecPtr = ^PAPStatusRec;
		PAPStatusRec = RECORD
				papSocket: SignedByte;	{ PAPOpen output: ATP responding socket }
				papFlow: SignedByte;	{ PAPOpen output: Printer's Flow quantum }
				papResult: Integer;		{ PAPOpen output: Result of last PAPOpen request }
				statusStr: STR255;		{ PAPOpen and PAPStatus output: Status string }
			END;

	FUNCTION PAPOpen (VAR refNum: INTEGER;
					  printerName: EntityPtr;
					  flowQuantum: INTEGER;
					  statusBuff: PAPStatusRecPtr;
					  VAR compState: OSErr): OSErr;

	FUNCTION WPAPClose (refNum: INTEGER): OSErr;

	FUNCTION WPAPRead (refNum: INTEGER;
					   readBuff: Ptr;
					   VAR dataSize: INTEGER;
					   VAR eof: INTEGER;
					   VAR compState: OSErr): OSErr;

	FUNCTION WPAPWrite (refNum: INTEGER;
						dataBuff: Ptr;
						dataSize: INTEGER;
						eof: INTEGER;
						VAR compState: OSErr): OSErr;

	FUNCTION PAPStatus (printerName: EntityPtr;
						statusBuff: PAPStatusRecPtr;
						VAR printerAddr: AddrBlock): OSErr;

	FUNCTION WPAPUnload: OSErr;

IMPLEMENTATION

END.